<template>
    <div>
        <Discount
            :data="data"
            key-code-name="discount_code"
            @checkChanged="checkChanged"
        />
        <div class="discount-group edit__set_block">
            <div class="row">
                <div class="col-md-4 form-title">
                    <b>Content</b>
                </div>
                <div class="col-md-8 text-right">
                    <b-select
                        v-model="selectedTagMenu"
                        class="form-control select-tags"
                        @change="addText"
                    >
                        <option
                            v-for="(value, index) in selectTagMenus"
                            :key="index"
                            :value="value.title"
                            :disabled="value.title === 'tags'"
                        >
                            {{ value.title }}
                        </option>
                    </b-select>
                </div>
            </div>
            <validation-provider
                v-slot="validationContext"
                name="bodyText"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Body Text</b>
                    </div>
                    <b-form-textarea
                        v-model="data.body_text"
                        name="body_text"
                        rows="3"
                        max-rows="6"
                        class="my-input full-width"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                        @blur="checkChanged"
                    />
                </b-form-group>
            </validation-provider>
            <validation-provider
                v-slot="validationContext"
                name="Unsubscribe text"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Unsubscribe Text</b>
                    </div>
                    <b-form-input
                        v-model="data.unsubscribe_text"
                        type="text"
                        class="my-input full-width"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                        @blur="checkChanged()"
                    />
                    <b-form-invalid-feedback>
                        {{ validationContext.errors[0] }}
                    </b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
            <div class="input-count-container">
                <span class="sms_counter">SMS counter: <b>{{ countOfMessages }}</b></span>
                <!-- <span>Characters left*:</span> -->
                <!-- <div style="width: 480px; margin-left: left;max-width: 100%;">
                    *Pay attention, this is an estimated number of the characters left. It&nbsp;depends on which symbols you’ll use: characters, numbers, special symbols etc.
                </div> -->
            </div>
            <validation-provider
                v-slot="validationContext"
                name="Footer"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Unsubscribe confirmation</b>
                    </div>
                    <b-form-textarea
                        v-model="data.unsubscribe_confirmation"
                        type="text"
                        class="full-width my-text-area"
                        name="Unsubscribe confirmation"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                        @blur="checkChanged"
                    >
                        {{ data.unsubscribe_confirmation }}
                    </b-form-textarea>
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
        </div>
    </div>
</template>

<script>
import {tags} from "@/mixins/add-tags"
import Discount from '@/components/edit/Discount.vue'

export default {
    name: "SmsCampaignForm",
    components: {
        Discount
    },
    mixins: [tags],
    props: {
        data: {
            type: Object,
            required: true,
            default: function () {
                return {automatic_discount_enabled: 0}
            }
        },
        countOfMessages: Number,
    },
    data: () => ({
        automatic_discount_enabled_options: [
            {value: true, text: 'Automatic'},
            {value: false, text: 'Pre-made'}
        ],
        selectTagMenus: [
            {
                title: 'tags'
            },
            {
                title: '{domain}'
            },
            {
                title: '{firstName}'
            },
            {
                title: '{lastName}'
            },
            {
                title: '{siteName}'
            },
            {
                title: '{discountValue}'
            },
            {
                title: '{discountCode}'
            },
            {
                title: '{storeEmail}'
            }
        ],
        selectedTagMenu: 'tags',
        focusedInput: 0,
        focusedName: '',
    }),
    methods: {
        addText() {
            if(this.focusedName) {
                const data = this.addTag(this.data, this.focusedName, this.focusedInput, this.selectedTagMenu)

                if(data.keys.length > 1) this.data[data.keys[0]][data.keys[1]] = data.value
                else this.data[data.keys[0]] = data.value

                this.focusedInput += this.selectedTagMenu.length
            }
            this.selectedTagMenu = 'tags'
        },
        checkChanged(key) {
            if(key)  this.$emit('checkChanged', key)
        },
        focus(e) {
            this.focusedInput = e.target.selectionStart;
            this.focusedName = e.target.name;
        },
        getValidationState({dirty, validated, valid = null}) {
            return dirty || validated ? valid : null;
        },
    }
};
</script>
<style  lang="scss">
    textarea.my-input {
        height: 9rem !important;
    }

    .input-count-container{
        text-align: right;
        .sms_counter {
            margin-right: 20px;
        }
    }

    .discount-container {
        margin-right: 20px;
        display: flex;
        align-items: center;

        .bv-no-focus-ring {
            display: flex;
            align-items: center;
        }
    }

    .code-container {
        display: flex;
        justify-content: space-between;
        align-items: center;
    }
</style>
